*****************************************
*****************************************
*****************************************

*****************************************
*					*
* descrunch any file			*
*					*
* from a0 to a1				*
* if pic, 16k buffer needed at a2	*
* if colrs stored palette goes to d1	*
* initial size of file in d0      	*
* 					*
* first word 				*
* 					*
* "SA" sout crunched anim file		*
* "SP" sout crunched pic file		*
* "SC" sout crunched pic file + colrs	*
* "SF" sout crunched data file		*
*					*
* returns length descrunched to in d0.l *
*					*
*****************************************

descrunch
		lea	desvars,a4

		move.l	d0,desbytesloaded(a4)
		move.l	d1,a5

		move.w	(a0),d0
		cmp.w	#"SA",d0
		beq.s	descrunpic
		cmp.w	#"SP",d0
		beq.s	descrunpic
		cmp.w	#"SC",d0
		beq.s	descrunpic2
		cmp.w	#"SF",d0
		beq	descrunfil
		move.l	desbytesloaded(a4),d7
		beq.s	.erk
.lp		move.b	(a0)+,(a1)+
		subq.l	#1,d7
		bne.s	.lp
.erk		
		move.l	desbytesloaded(a4),d0
		rts

*****************************************

picd7out	macro
		subq.w	#1,d4
		and.w	#$3fff,d4
.skip		move.b	d7,(a2,d4)
		addq.l	#1,d2
		endm

*****************************************

picgetbit	macro

		add.l	d0,d0	
		bne.s	.out	
		move.l	-(a0),d0	
		move.w	#-1,ccr
		addx.l	d0,d0
.out		
		endm

*****************************************

getd7data
		move.w	desdplanes(a4),d1
		moveq	#0,d7
.loop		picgetbit
		roxr.b	#1,d7
		dbra	d1,.loop
		rts

*****************************************

desrptminvals	dc.b	7,5,4,4
dessamminvals	dc.b	4,4,3,3

*****************************************


		;from a0 to a1 , needs 16384 workspace at a2
		;palette goes to d1 if "SC"
		;returns size loaded in d0
descrunpic:	
		clr.w	despaletteflag(a4)
		bra.s	descrunp
descrunpic2:	
		move.w	#1,despaletteflag(a4)
descrunp
		movem.l	d1-d7/a0-a6,-(sp)
		move.l	d1,a5

		move.l	a1,a3
		moveq	#0,d7		;spritefileflag
		cmp.w	#"SA",(a0)+
		bne.s	.notsp
		moveq	#-1,d7		;spritefileflag
.notsp		

		move.w	(a0)+,desdplanes(a4)
		move.l	(a0)+,desplasize(a4)
		move.w	desdplanes(a4),d0
		lea	desrptminvals(pc),a1
		move.b	#0,desrptmin(a4)		
		move.b	#0,dessammin(a4)
		move.b	-3(a1,d0),desrptmin+1(a4)		;start on 3, read byte only
		move.b	-3+dessamminvals-desrptminvals(a1,d0),dessammin+1(a4)
		move.l	(a0)+,d0			;len of codes in bytes

		tst.w	despaletteflag(a4)
		beq.s	.skpal
		moveq	#0,d1
		move.w	desdplanes(a4),d2
		bset	d2,d1
		subq.w	#1,d1
.lp		move.w	(a0)+,(a5)+
		dbra	d1,.lp		
.skpal
		add.l	d0,a0				;a0 = end+1 of codes/start of sprite header
		clr.l	dessavefilesize(a4)
		tst.l	d7				;spritefileflag
		beq.s	.notsp2
		move.l	a0,a1
		move.l	8(a1),d0
		addq.l	#8,d0
		move.l	d0,dessavefilesize(a4)
.nex		move.b	(a1)+,(a3)+
		subq.l	#1,d0
		bne.s	.nex
.notsp2
		move.l	a3,a1	
		add.l	desplasize(a4),a3

		move.w	desdplanes(a4),d7
		moveq	#0,d0
.nex2		add.l	desplasize(a4),d0
		subq.w	#1,d7
		bne.s	.nex2

		add.l	d0,dessavefilesize(a4)	;for save out file
		subq.w	#1,desdplanes(a4)	;ready for dbf

		move.w	desdplanes(a4),d7		;0-5 not 1-6 (3-6)
		add.w	d7,d7
		add.w	d7,d7
		lea	-8+transtab(pc),a6	;start on 3
		add.l	(a6,d7),a6
		addq.l	#8,a6

		moveq	#0,d2		;count of bytes optted and not txfmd
		move.w	#$4000,d4	;buffer start
		move.w	#$4000,d5	;buffer start for trans

		move.l	-(a0),d0	;first long of data
loopcode

		moveq	#4,d1
		bsr.s	picgetd7
		add.w	d7,d7		
		add.w	d7,d7		

		move.l	a1,-(sp)
		lea	jmptab(pc),a1
		add.l	(a1,d7),a1
		jsr	(a1)
		move.l	(sp)+,a1

aftercode

		cmp.l	a3,a1		;all done ?
		beq.s	.done
		cmp.w	#16,d2		;check if 16 bytes there to do
		bcs.s	loopcode
		sub.w	#16,d5
		and.w	#$3ff0,d5	;position to trans from		
		lea	(a2,d5),a5
		sub.w	#16,d2
		jsr	(a6)		;transtab
		bra.s	aftercode
.done
		movem.l	(sp)+,d1-d7/a0-a6
		move.l	dessavefilesize(a4),d0
		rts

*****************************************
